/*
2023-01-06
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#ifndef PICO_FMETER_H
#define PICO_FMETER_H

#define BIT(x) (1<<x)

#define DEF_SYSCLOCK     133000000  // default
#define MHZ_12            12000000  // default
#define AS6501_REF        10000000  // TCXO or ext. clock

#define MHZ_FAKTOR        1000000   // 1e6
#define MS_TEILER         1000      // us -> ms

#define REF_DIV           2         // PLL-Schrittweite 6 MHZ @ 12 MHz bzw. 5 MHz @ 10 MHz
#define PLL_DIV1          5         // force high F_vco
#define PLL_DIV2          2         // default = 2; 1 => turbo-mode

#define F1_TIMER          7         // Timer 7 1Khz
#define REG_TIMER         6         // Timer 6 50 kHz

#define TYP_LED_ZEIT      50        // 50 ms

#define INT_REQ           14        // Eingang
#define EXT_LED           15        // externe LED
#define PRE_MUX_OUT       16        // 1=Vorteiler 4:1 aktiv
#define CAP1_PIN          17        // PIO0-SM2: capture Ereigniszaehler 
#define GPIO18            18        // frei bzw. Laufzeitmessung
#define EXT_REF_IN        19        // Test auf ext. 10 MHz
#define REF_MUX_IN_OUT    20        // Abfrage oder gezielte Umschaltung
#define FIN1_PIN          21        // PIO-SM1-Input: Ereigniszaehler per DMA_CH1
#define FREF_PIN          22        // PIO-Input, wenn benutzt
#define LOCAL_LED         25        // on board

#define ADC_POTI          2         // GPIO28
#define ADC_MAX           4095
#define ADC_FILTER        30        // ext. R-trimm

#define DEF_BAUDRATE      115200

#endif